## gnudatalanguage 0.9.9

=== CMakeLists.txt ===
#
# copyright : (c) 2010 Maxime Lenoir and Alain Coulais
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#

cmake_minimum_required(VERSION 3.0 FATAL_ERROR)

# requirement for CMAKE_CXX_STANDARD (3.2 for Apple, 3.1 for non-Apple: https://public.kitware.com/Bug/bug_relationship_graph.php?bug_id=15355)
if (${CMAKE_VERSION} VERSION_LESS "3.2")
  string(FIND "${CMAKE_CXX_FLAGS}" "-std=c++11" tmp)
  if(tmp LESS 0)
    message(FATAL_ERROR "please upgrade CMake to a version 3.2 or higher OR rerun cmake with -DCMAKE_CXX_FLAGS=\"-std=c++11\"")
  endif()
else()
  set(CMAKE_CXX_STANDARD 11)
endif()

cmake_policy(SET CMP0026 OLD) # LOCATION property

project(GDL)
set(CMAKE_CXX_STANDARD 11)

# advice by Orion, mandatory for FC 28
set(CMAKE_POSITION_INDEPENDENT_CODE ON)

# X.X.X git becomes release X.X.X+1
set(VERSION "0.9.9")
enable_testing()

# cf issue 511, managing MultiArch on Debian ...
include(GNUInstallDirs)

include(CheckIncludeFile)
include(CheckIncludeFileCXX)
include(CheckLibraryExists)
include(CheckFunctionExists)
include(CheckSymbolExists)
include(CheckCSourceRuns)
include(CheckCXXSourceCompiles)
include(FindPkgConfig)
include(FindPackageHandleStandardArgs)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_SOURCE_DIR}/CMakeModules)

#### Default cached values
set(PYTHON_MODULE OFF CACHE BOOL "GDL: Build GDL as a Python module ?")

set(X11 ON CACHE BOOL "GDL: Enable X11 ?") 
set(X11DIR "" CACHE PATH "GDL: Specify X11 directory tree")

# GNU Readline or BSD Editline ? if Readline OK, we don't look for Editline.
set(READLINE ON CACHE BOOL "GDL: Enable GNU Readline ?")
set(READLINEDIR "" CACHE PATH "GDL: Specify the GNU Readline directory tree")

set(EDITLINE ON CACHE BOOL "GDL: Enable BSD Editline ?")
set(EDITLINEDIR "" CACHE PATH "GDL: Specify the BSD Editline directory tree")

set(PLPLOTDIR "" CACHE PATH "GDL: Specify the plplot directory tree")

set(GSLDIR "" CACHE PATH "GDL: Specify the GSL directory tree")

set(ZLIBDIR "" CACHE PATH "GDL: Specify the Zlib directory tree")

set(WXWIDGETS ON CACHE BOOL "GDL: Enable WxWidgets ?")
set(WXWIDGETSDIR "" CACHE PATH "GDL: Specify WxWidgets directory tree")

set(UDUNITS OFF CACHE BOOL "GDL: Enable UDUNITS-2 ?")
set(UDUNITSDIR "" CACHE PATH "GDL: Specify the UDUNITS-2 directory tree")

set(EIGEN3 ON CACHE BOOL "GDL: Enable Eigen3 ?")
set(EIGEN3DIR "" CACHE PATH "GDL: Specify the Eigen3 directory tree")

set(PSLIB ON CACHE BOOL "GDL: Enable pslib ?")
set(PSLIBDIR "" CACHE PATH "GDL: Specify the pslib directory tree")

set(PNGLIB ON CACHE BOOL "GDL: Enable libpng ?")
set(PNGLIBDIR "" CACHE PATH "GDL: Specify the libpng directory tree")

set(GRIB OFF CACHE BOOL "GDL: Enable GRIB ?")
set(GRIBDIR "" CACHE PATH "GDL: Specifiy the ECMWF ecCodes or GRIB API directory tree")

# set(QHULL OFF CACHE BOOL "GDL: Enable Qhull ?")
# set(QHULLDIR "" CACHE PATH "GDL: Specifiy the QHULL directory tree")

set(GLPK OFF CACHE BOOL "GDL: Enable GLPK (for function SIMPLEX) ?")
set(GLPKDIR "" CACHE PATH "GDL: Specify the GLPK directory tree")

# GraphicsMagick is a good alternative to ImageMagick, if GM OK, we don't look for IM
set(GRAPHICSMAGICK ON CACHE BOOL "GDL: Enable GraphicsMagick ?")
set(GRAPHICSMAGICKDIR "" CACHE PATH "GDL: Specify the GraphicsMagick directory tree")

set(MAGICK ON CACHE BOOL "GDL: Enable ImageMagick ?")
set(MAGICKDIR "" CACHE PATH "GDL: Specifiy the ImageMagick directory tree")

set(TIFF ON CACHE BOOL "GDL: Enable libtiff ?")
set(TIFFDIR "" CACHE PATH "GDL: Specify the libtiff directory tree")

if(TIFF)
	set(GEOTIFF ON CACHE BOOL "GDL: Enable libgeotiff ?")
	set(GEOTIFFDIR "" CACHE PATH "GDL: Specify the libgeotiff directory tree")
endif(TIFF)

set(NETCDF ON CACHE BOOL "GDL: Enable NetCDF ?")
set(NETCDFDIR "" CACHE PATH "GDL: Specifiy the netCDF directory tree")

set(HDF ON CACHE BOOL "GDL: Enable Hdf ?")
set(HDFDIR "" CACHE PATH "GDL: Specifiy the HDF directory tree")

set(HDF5 ON CACHE BOOL "GDL: Enable Hdf5 ?")
set(HDF5DIR "" CACHE PATH "GDL: Specifiy the HDF5 directory tree")

set(FFTW ON CACHE BOOL "GDL: Enable FFTW ?")
set(FFTWDIR "" CACHE PATH "GDL: Specifiy the FFTW directory tree")

set(LIBPROJ4 OFF CACHE BOOL "GDL: Enable LIBPROJ4 ?")
set(LIBPROJ4DIR "" CACHE PATH "GDL: Specifiy the LIBPROJ4 directory tree")

set(MPICH OFF CACHE BOOL "GDL: Enable MPICH ?")
set(MPICHDIR "" CACHE PATH "GDL: Specify the MPICH (experimental) directory tree")

set(PYTHON ON CACHE BOOL "GDL: Enable Python ?")
set(PYTHONDIR "" CACHE PATH "GDL: Specifiy the use Python directory tree")
set(PYTHONVERSION "" CACHE STRING "GDL: Specify the Python version to use")

set(GSHHS ON CACHE BOOL "GDL: Enable GSHHS ?")
set(GSHHSDIR "" CACHE PATH "GDL: Specifiy the GSHHS directory tree")

if(NOT WIN32)
  set(NCURSESDIR "" CACHE PATH "GDL: Specify the ncurses (or curses) directory tree")
endif(NOT WIN32)

set(OPENMP ON CACHE BOOL "GDL: Enable OpenMP ?")

# Third party libraries
set(JASPERDIR "" CACHE PATH "GDL: Specify the JasPer directory tree")
set(JPEGDIR "" CACHE PATH "GDL: Specify the JPEG directory tree")
set(SZIPDIR "" CACHE PATH "GDL: Specify the SZip directory tree")

set(GDL_DATA_DIR "/share/gnudatalanguage" CACHE PATH "GDL: data directory relative to CMAKE_INSTALL_PREFIX")

# check for 64-bit OS
if(${CMAKE_SIZEOF_VOID_P} EQUAL 8)
	set(HAVE_64BIT_OS 1)
endif(${CMAKE_SIZEOF_VOID_P} EQUAL 8)

#### check headers and libraries

# dl
check_library_exists(dl dlopen "" HAVE_DL)
if(HAVE_DL)
	set(LIBRARIES ${LIBRARIES} dl)
endif(HAVE_DL)

# malloc stats
check_function_exists(malloc_zone_statistics HAVE_MALLOC_ZONE_STATISTICS)
check_function_exists(sbrk HAVE_SBRK)
check_function_exists(mallinfo HAVE_MALLINFO)

# mallocs
check_include_file(malloc.h HAVE_MALLOC_H)
check_include_file(malloc/malloc.h HAVE_MALLOC_MALLOC_H)

# locale
check_include_file(locale.h HAVE_LOCALE_H)

# std includes..
check_include_file(stdint.h HAVE_STDINT_H)
check_include_file(stdlib.h HAVE_STDLIB_H)
check_include_file(string.h HAVE_STRING_H)
check_include_file(strings.h HAVE_STRINGS_H)
check_include_file(sys/stat.h HAVE_SYS_STAT_H)
check_include_file(sys/types.h HAVE_SYS_TYPES_H)
check_include_file(unistd.h HAVE_UNISTD_H)
#check_include_file(ext/stdio_filebuf.h HAVE_EXT_STDIO_FILEBUF_H)
#sometimes it compiles but stdio_filebuf is only in gcc-x-y-z directory tree...
# would be silly not to use this functionality if present, so recheck:
if (HAVE_EXT_STDIO_FILEBUF_H)
else (HAVE_EXT_STDIO_FILEBUF_H)
	check_cxx_source_compiles("
#include <ext/stdio_filebuf.h>
int main(int argc, char **argv) {
    int i=0;
    i+=1;
}" REALLY_HAVE_EXT_STDIO_FILEBUF_H)
endif (HAVE_EXT_STDIO_FILEBUF_H)
if (REALLY_HAVE_EXT_STDIO_FILEBUF_H)
message(STATUS "INFO: will use GNU extensions for STDIO (useful for compressed I/O) since it seems accepted by your c++ compiler.")
set (HAVE_EXT_STDIO_FILEBUF_H 1)
endif (REALLY_HAVE_EXT_STDIO_FILEBUF_H)
# dlfcn.h
check_include_file(dlfcn.h HAVE_DLFCN_H)

# inttypes.h
check_include_file(inttypes.h HAVE_INTTYPES_H)

# nexttoward
check_library_exists(m nexttoward "" HAVE_NEXTTOWARD)

# mpi
check_include_file(mpi.h HAVE_MPI_H)

# SA: whithout it compilation of antlr fails if there's a conflicting 
#     version of antlr in system-wide directories
include_directories(src)

if (NOT WIN32)
	# Ncurses MANDATORY for readline on POSIX
	# -DNCURSESDIR=DIR
	set(CMAKE_PREFIX_PATH ${NCURSESDIR})	
	set(CURSES_NEED_NCURSES TRUE)
	find_package(Curses QUIET COMPONENTS initscr)
	mark_as_advanced(CURSES_CURSES_H_PATH CURSES_FORM_LIBRARY CURSES_HAVE_CURSES_H)
	if(CURSES_FOUND)
		set(HAVE_LIBNCURSES 1)
		set(LIBRARIES ${LIBRARIES} ${CURSES_LIBRARIES})
		include_directories(${CURSES_INCLUDE_DIR})
	else(CURSES_FOUND)
		# search for curses
		set(CURSES_NEED_NCURSES FALSE)
		find_package(Curses COMPONENTS initscr)
		set(HAVE_LIBCURSES ${CURSES_FOUND})
		if(CURSES_FOUND)
			set(LIBRARIES ${LIBRARIES} ${CURSES_LIBRARIES})
			include_directories(${CURSES_INCLUDE_DIR})
		else(CURSES_FOUND)
			message(FATAL_ERROR "(N)Curses was not found.\n"
				"Use -DNCURSESDIR=DIR to specify the curses directory tree.\n"
				"(suitable Debian/Ubuntu package: libncurses-dev)\n")
		endif(CURSES_FOUND)
	endif(CURSES_FOUND)
endif (NOT WIN32)

# GNU Readline (GNU/Linux or OSX) or BSD Editline (OSX)

# -DREADLINE=ON|OFF
# -DREADLINEDIR=DIR or -DEDITLINEDIR=DIR
if(READLINE)
  set(CMAKE_PREFIX_PATH ${READLINEDIR})
  find_package(Readline QUIET)
  set(HAVE_LIBREADLINE ${READLINE_FOUND})
  if(READLINE_FOUND)
    if(NOT WIN32)
      # readline needs (n)curses (not on Windows)
      set(CMAKE_REQUIRED_LIBRARIES ${CURSES_LIBRARIES})
    endif(NOT WIN32)
    check_library_exists("${READLINE_LIBRARIES}" rl_get_screen_size "" RL_GET_SCREEN_SIZE)
    if(NOT RL_GET_SCREEN_SIZE)
      message(STATUS "WARNING: Older GNU readline without rl_get_screen_size was found.\n"
	"For resized terminals the size might not be updated correctly.\n"
	"If this is a problem please install a recent version of readline.")
    endif(NOT RL_GET_SCREEN_SIZE)
    set(LIBRARIES ${LIBRARIES} ${READLINE_LIBRARIES})
    include_directories(${READLINE_INCLUDE_DIR})
    set(CMAKE_REQUIRED_LIBRARIES)
  else(READLINE_FOUND)
    if(EDITLINE)
      message(STATUS "WARNING: GNU readline was not found, now looking for BSD Editline.\n")
    else(EDITLINE)
      message(FATAL_ERROR "GNU readline was not found.\n"
	"Use -DREADLINEDIR=no to explicitely disable it.\n"
	"(suitable Debian/Ubuntu package: libreadline-gplv2-dev)\n"
	"(suitable Fedora package: readline-devel)")
    endif(EDITLINE)    
  endif(READLINE_FOUND)
endif(READLINE)
#
# if Readline found, we do not look for Editline
#
if(READLINE_FOUND)
  if (EDITLINE)
    message(STATUS "INFO: We prefer to use Readline than Editline.\n"
      "Feedback welcome on OSX Readline ...")
    set(EDITLINE OFF)
  endif(EDITLINE)
endif(READLINE_FOUND)

# BSD Editline (a BSD clone of GNU Readline, present by default on OSX)
# -DEDITLINE=ON|OFF
# -DEDITLINEDIR=DIR
if(EDITLINE)
  set(CMAKE_PREFIX_PATH ${EDITLINEDIR})
  find_package(Editline CONFIG)
	if(NOT EDITLINE_FOUND)
	  find_package(Editline QUIET)
	endif(NOT EDITLINE_FOUND)
  set(HAVE_LIBEDITLINE ${EDITLINE_FOUND})
  if(EDITLINE_FOUND)
    if(NOT WIN32)
      # readline needs (n)curses (not on Windows)
      set(CMAKE_REQUIRED_LIBRARIES ${CURSES_LIBRARIES})
    endif(NOT WIN32)
    set(LIBRARIES ${LIBRARIES} ${EDITLINE_LIBRARIES})
    include_directories(${EDITLINE_INCLUDE_DIR})
    set(CMAKE_REQUIRED_LIBRARIES)
  else(EDITLINE_FOUND)
    message(FATAL_ERROR "requested BSD Editline was not found.\n"
      "Use -DEDITLINE=no to explicitely disable it.\n")
  endif(EDITLINE_FOUND)
endif(EDITLINE)

# zlib MANDATORY
# -DZLIBDIR=DIR
set(CMAKE_PREFIX_PATH ${ZLIBDIR})
find_package(ZLIB QUIET)
set(HAVE_LIBZ ${ZLIB_FOUND})
if(ZLIB_FOUND)
	set(LIBRARIES ${LIBRARIES} ${ZLIB_LIBRARIES})
	include_directories(${ZLIB_INCLUDE_DIR})
else(ZLIB_FOUND)
	message(FATAL_ERROR "ZLib library is required but was not found.\n"
	"Use -DZLIBDIR=DIR to specify the zlib directory tree.\n"
        "(suitable Debian/Ubuntu package: zlib1g-dev)\n"
        "(suitable Fedora package: zlib-devel)")
endif(ZLIB_FOUND)

# libpng
# -DPNGLIB=ON|OFF
# -DPNGLIBDIR=DIR
if(PNGLIB)
	set(CMAKE_PREFIX_PATH ${PNGLIBDIR})
	find_package(PNG QUIET)
	set(USE_PNGLIB ${PNG_FOUND})
	if(PNG_FOUND)
		set(LIBRARIES ${LIBRARIES} ${PNG_LIBRARIES})
		set(LINK_DIRECTORIES ${LINK_DIRECTORIES} ${PNG_LIBRARY_DIRS})
		include_directories(${PNG_INCLUDE_DIRS})
	else(PNG_FOUND)
		message(FATAL_ERROR "libpng is required but was not found.\n"
		"Use -DPNGLIBDIR=DIR to specify the libpng directory tree.\n"
		"Use -DPNGLIB=OFF to not use it.\n"
                "(suitable Debian/Ubuntu package: libpng-dev)\n"
                "(suitable Fedora package: libpng-devel)")
	endif(PNG_FOUND)
endif(PNGLIB)

# openmp
# -DOPENMP=ON|OFF
if(OPENMP)

=== src/CMakeLists.txt ===
set(SOURCES
CFMTLexer.cpp
CFMTLexer.hpp
CFMTTokenTypes.hpp
FMTIn.cpp
FMTIn.hpp
FMTInTokenTypes.hpp
FMTLexer.cpp
FMTLexer.hpp
FMTOut.cpp
FMTOut.hpp
FMTOutTokenTypes.hpp
FMTParser.cpp
FMTParser.hpp
FMTTokenTypes.hpp
GDLInterpreter.cpp
GDLInterpreter.hpp
GDLInterpreterTokenTypes.hpp
GDLLexer.cpp
GDLLexer.hpp
GDLParser.cpp
GDLParser.hpp
GDLTokenTypes.hpp
GDLTreeParser.cpp
GDLTreeParser.hpp
GDLTreeParserTokenTypes.hpp
datatypes.cpp
datatypes.hpp
datatypesref.cpp
datatypes_minmax.cpp
accessdesc.hpp
allix.hpp
allix.cpp
arrayindex.cpp
arrayindex.hpp
arrayindexlistt.hpp
arrayindexlistnoassoct.hpp
assocdata.cpp
assocdata.hpp
basegdl.cpp
basegdl.hpp
basic_fun.cpp
basic_fun.hpp
basic_fun_cl.cpp
basic_fun_cl.hpp
basic_fun_jmg.cpp
basic_fun_jmg.hpp
basic_op.cpp
calendar.hpp
calendar.cpp
cformat.g
color.cpp
color.hpp
convert2.cpp
convol.cpp
datalistt.hpp
dcommon.cpp
dcommon.hpp
dcompiler.cpp
dcompiler.hpp
default_io.cpp
deviceps.hpp
devicesvg.hpp
devicez.hpp
dimension.hpp
dialog.cpp
dialog.hpp
dinterpreter.cpp
dinterpreter.hpp
dnode.cpp
dnode.hpp
dnodefactory.hpp
dpro.cpp
dpro.hpp
dstructdesc.cpp
dstructdesc.hpp
dstructfactory.cxx
dstructfactory.hxx
dstructgdl.cpp
dstructgdl.hpp
dvar.cpp
dvar.hpp
envt.cpp
envt.hpp
extrat.cpp
extrat.hpp
exists_fun.cpp
exists_fun.hpp
fftw.cpp
fftw.hpp
file.cpp
file.hpp
fmtnode.cpp
fmtnode.hpp
format.g
format.in.g
format.out.g
gdlc.g
gdlc.i.g
gdlc.tree.g
gdleventhandler.cpp
gdleventhandler.hpp
gdlexception.cpp
gdlexception.hpp
gdlgstream.cpp
gdlgstream.hpp
dSFMT/dSFMT.c
)
if(WIN32)
set(SOURCES
${SOURCES}
gdlwinstream.cpp
gdlwinstream.hpp
gtdhelper.cpp
gtdhelper.hpp
devicewin.hpp
devicewin.cpp
)
else(WIN32)
set(SOURCES
${SOURCES}
devicex.hpp
gdlxstream.cpp
gdlxstream.hpp
)
endif(WIN32)
set(SOURCES
${SOURCES}
gdljournal.cpp
gdljournal.hpp
gdlhelp.cpp
gdlpsstream.cpp
gdlpsstream.hpp
gdlpython.cpp
gdlpython.hpp
gdlsvgstream.cpp
gdlsvgstream.hpp
gdlwidget.cpp
gdlwidgeteventhandler.cpp
gdlwidget.hpp
gdlwxstream.cpp
gdlwxstream.hpp
gdlzstream.cpp
gdlzstream.hpp
getfmtast.cpp
getfmtast.hpp
graphicsdevice.cpp
graphicsdevice.hpp
basic_pro.cpp
basic_pro.hpp
basic_pro_jmg.cpp
basic_pro_jmg.hpp
brent.cpp
grib.cpp
grib.hpp
gshhs.cpp
gshhs.hpp
gsl_fun.cpp
gsl_fun.hpp
gsl_matrix.cpp
gsl_matrix.hpp
gzstream.hpp
hash.cpp
hash.hpp
hdf5_fun.cpp
hdf5_fun.hpp
hdf_fun.cpp
hdf_fun.hpp
hdf_pro.cpp
hdf_pro.hpp
ifmt.cpp
image.cpp
image.hpp
initct.cpp
initsysvar.cpp
initsysvar.hpp
io.cpp
io.hpp
lapack.cpp
least_squares.cpp
least_squares.hpp
libinit.cpp
libinit_ac.cpp
libinit_cl.cpp
libinit_gm.cpp
libinit_jmg.cpp
libinit_mes.cpp
libinit_ng.cpp
libinit_jp.cpp
libinit_exists.cpp
linearprogramming.cpp
list.cpp
list.hpp
magick_cl.cpp
magick_cl.hpp
math_fun.cpp
math_fun.hpp
math_fun_ac.cpp
math_fun_ac.hpp
math_fun_gm.cpp
math_fun_gm.hpp
math_fun_jmg.cpp
math_fun_jmg.hpp
math_fun_ng.cpp
math_fun_ng.hpp
math_utl.cpp
math_utl.hpp
matrix_cholesky.cpp
matrix_cholesky.hpp
matrix_invert.cpp
matrix_invert.hpp
mpi.cpp
mpi.hpp
ncdf_att_cl.cpp
ncdf_cl.cpp
ncdf_cl.hpp
ncdf_dim_cl.cpp
ncdf_var_cl.cpp
ncdf4_group.cpp
new.cpp
new.hpp
newprognode.cpp
nullgdl.cpp
nullgdl.hpp
objects.cpp
objects.hpp
ofmt.cpp
ofmt.hpp
overload.cpp
overload.hpp
plotting_axis.cpp
plotting_contour.cpp
plotting_convert_coord.cpp
plotting_cursor.cpp
plotting_device.cpp
plotting_erase.cpp
plotting_image.cpp
plotting_map_proj.cpp
plotting_misc.cpp
plotting_oplot.cpp
plotting_plot.cpp
plotting_plots.cpp
plotting_polyfill.cpp
plotting_shade_surf.cpp
plotting_surface.cpp
plotting_windows.cpp
plotting_xyouts.cpp
plotting.cpp
plotting.hpp
print.cpp
print_tree.cpp
print_tree.hpp
prognode.cpp
prognode_lexpr.cpp
prognodeexpr.cpp
randomgenerators.cpp
read.cpp
real2int.hpp
saverestore.cpp
semshm.cpp
semshm.hpp
sigfpehandler.cpp
sigfpehandler.hpp
smooth.cpp
smooth.hpp
specializations.hpp
str.cpp
str.hpp
terminfo.cpp
terminfo.hpp
tiff.cxx
tiff.hxx
topython.cpp
triangulation.cpp
typedefs.hpp
typetraits.cpp
typetraits.hpp
where.cpp
widget.cpp
widget.hpp
)

add_subdirectory(antlr)

include_directories(${CMAKE_SOURCE_DIR} ${CMAKE_SOURCE_DIR}/src ${CMAKE_SOURCE_DIR}/src/antlr ${CMAKE_BINARY_DIR})
link_directories(${LINK_DIRECTORIES})

if(PYTHON_MODULE) #GDL.so
	set(SOURCES ${SOURCES} pythongdl.cpp)
	add_library(gdl SHARED ${SOURCES})
	SET_TARGET_PROPERTIES(gdl PROPERTIES PREFIX "")
	SET_TARGET_PROPERTIES(gdl PROPERTIES OUTPUT_NAME GDL)
	SET_TARGET_PROPERTIES(gdl PROPERTIES NO_SONAME TRUE)
        SET_TARGET_PROPERTIES(gdl PROPERTIES SUFFIX ".so") # e.g. Mac defaults to .dylib which is not looked for by Python
else(PYTHON_MODULE) #GDL.so
	set(SOURCES ${SOURCES} gdl.cpp)
	add_executable(gdl ${SOURCES})
endif(PYTHON_MODULE)

add_dependencies(gdl antlr) # be sure that antlr is built before gdl
target_link_libraries(gdl antlr) # link antlr against gdl
if (MINGW)
target_link_libraries(gdl ws2_32)
endif (MINGW)
target_link_libraries(gdl ${LIBRARIES})
add_definitions(-DHAVE_CONFIG_H)

if(PYTHON_MODULE)
	find_package( PythonInterp REQUIRED )
	execute_process(COMMAND ${PYTHON_EXECUTABLE} -c
		"import site, sys; sys.stdout.write(site.PREFIXES[-1])"
			OUTPUT_VARIABLE PYTHON_PREFIX)
	file( TO_CMAKE_PATH "${PYTHON_PREFIX}" PYTHON_PREFIX)
        execute_process(COMMAND ${PYTHON_EXECUTABLE} -c
		"import site, sys; sys.stdout.write(site.getsitepackages()[-1])"
			OUTPUT_VARIABLE PYTHON_SITE_DIR)
	file( TO_CMAKE_PATH "${PYTHON_SITE_DIR}" PYTHON_SITE_DIR )
	string( REGEX REPLACE "^${PYTHON_PREFIX}/" ""
	       PYTHON_SITE_DIR "${PYTHON_SITE_DIR}")
	install(TARGETS gdl DESTINATION ${PYTHON_SITE_DIR})
else(PYTHON_MODULE)
	install(TARGETS gdl DESTINATION ${CMAKE_INSTALL_PREFIX}/bin)
	set_target_properties(gdl PROPERTIES INSTALL_RPATH_USE_LINK_PATH TRUE)
endif(PYTHON_MODULE)

install(DIRECTORY ${CMAKE_SOURCE_DIR}/src/pro/ DESTINATION ${CMAKE_INSTALL_PREFIX}/${GDL_DATA_DIR}/lib
	PATTERN CVS EXCLUDE
	PATTERN checks EXCLUDE
	PATTERN Makefile* EXCLUDE
	PATTERN UrgentNeed.txt EXCLUDE)

=== testsuite/CMakeLists.txt ===
set(BASE_SOURCE ${CMAKE_SOURCE_DIR})
set(BASE_BINARY ${CMAKE_BINARY_DIR})
# write the test launcher
if(WIN32 AND NOT CYGWIN)
set(LAUNCH
"#define _CRT_SECURE_NO_WARNINGS
#include <stdio.h>
#include <malloc.h>
#ifndef _MSC_VER
#include <unistd.h>
#endif
int main(int c,char**v) {
char*p;
if(c!=2) return 1;
for(p=v[1];*p;++p);
if(p-4<v[1]) return 1;
if(p[-1]!='o'||p[-2]!='r'||p[-3]!='p'||p[-4]!='.') return 1;
*(p-4)=0;

_putenv(\"LC_COLLATE=C\");
_putenv(\"GDL_PATH=${BASE_SOURCE}/testsuite/;${BASE_SOURCE}/src/pro/\");
_putenv(\"GDL_STARTUP=\");
_putenv(\"IDL_STARTUP=\");

char *tmp = (char *)malloc( sizeof(char) * (strlen(\"${BASE_BINARY}/src/gdl -quiet -e \") + strlen(v[1]) + 1));
//PROCESS_INFORMATION processInformation = {0};
//STARTUPINFO startupInfo                = {0};
//startupInfo.cb                         = sizeof(startupInfo);
sprintf(tmp, \"${BASE_BINARY}/src/gdl.exe -quiet -e %s\", v[1]);
//int rtn = CreateProcess(NULL, tmp, NULL, NULL, TRUE, 0, NULL, NULL, &startupInfo, &processInformation);
int rtn = system(tmp);

if (rtn == 77) {
    printf(\"TEST SKIPPED\");
    exit(0);
} if (rtn == -1 || rtn == 127) {
    printf(\"LAUNCH PROCESS FAILED\");
    exit(1);
} else {
    exit(rtn);
}
}
")
else(WIN32 AND NOT CYGWIN)
set(LAUNCH
"#include<unistd.h>
#include<stdlib.h>
#include<stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/wait.h>
#include<sched.h>
int main(int c,char**v) {
char*p;
if(c!=2) return 1;
for(p=v[1];*p;++p);
if(p-4<v[1]) return 1;
if(p[-1]!='o'||p[-2]!='r'||p[-3]!='p'||p[-4]!='.') return 1;
*(p-4)=0;
setenv(\"LC_COLLATE\",\"C\",1);
setenv(\"GDL_PATH\",\"+${BASE_SOURCE}/testsuite/:+${BASE_SOURCE}/src/pro/\",1);
unsetenv(\"GDL_STARTUP\");
unsetenv(\"IDL_STARTUP\");
int devnull = open(\"/dev/null\",O_RDONLY);
dup2(devnull, 0);
int child_pid = fork();
if(child_pid == 0) {
  execl(\"${BASE_BINARY}/src/gdl\",\"-quiet\",\"-e\",v[1],(char*)0);
  exit(1);
} else {
  sched_yield();
  int child_status;
  waitpid(child_pid, &child_status, 0);
  if (WEXITSTATUS(child_status) == 77) {
    printf(\"TEST SKIPPED\");
    exit(0);
  } else if (WIFSIGNALED(child_status)) {
    printf(\"TEST EXITED FROM SIGNAL %d\", WTERMSIG(child_status));
    exit(1);
  } else {
    exit(WEXITSTATUS(child_status));
  }
}
}
")
endif(WIN32 AND NOT CYGWIN)
file(WRITE ${CMAKE_SOURCE_DIR}/testsuite/launchtest.c "${LAUNCH}")
add_executable(launchtest EXCLUDE_FROM_ALL ${CMAKE_SOURCE_DIR}/testsuite/launchtest.c)
if(OPENMP_FOUND)
  remove_definitions(${OpenMP_CXX_FLAGS})
endif()
add_library(test_ce SHARED EXCLUDE_FROM_ALL libtest_ce.cpp)
add_custom_target(check COMMAND ${CMAKE_BUILD_TOOL} test DEPENDS launchtest test_ce gdl)
get_target_property(LAUNCHTESTLOCATION launchtest LOCATION)
if(WIN32 AND NOT CYGWIN)
  file(READ "${BASE_SOURCE}/testsuite/Makefile.am" MAKEFILEAM)
  string(REGEX MATCHALL "test[_a-zA-Z0-9]+\\.pro" TESTS ${MAKEFILEAM})
else(WIN32 AND NOT CYGWIN)
  execute_process(
    COMMAND "fgrep" ".pro" "${BASE_SOURCE}/testsuite/Makefile.am" 
    COMMAND "awk" "{printf(\"%s;\",$1)}" 
    OUTPUT_VARIABLE TESTS)
endif(WIN32 AND NOT CYGWIN)
foreach(TEST ${TESTS})
	add_test(${TEST} ${LAUNCHTESTLOCATION} ${TEST})
	set_tests_properties(${TEST} PROPERTIES SKIP_RETURN_CODE 77) # autoconf's setting
endforeach(TEST TESTS)

=== examples/call_external_0/CMakeLists.txt ===
project(libexaple C)
cmake_minimum_required(VERSION 2.0)
add_library(example SHARED libexample.c) 
set_directory_properties(PROPERTIES ADDITIONAL_MAKE_CLEAN_FILES 
  "Makefile;CMakeCache.txt;cmake_install.cmake;CMakeFiles")

=== src/antlr/CMakeLists.txt ===
aux_source_directory(${CMAKE_CURRENT_SOURCE_DIR} ANTLRSOURCES)
list(REMOVE_ITEM ANTLRSOURCES ${CMAKE_CURRENT_SOURCE_DIR}/dll.cpp)
include_directories(${CMAKE_SOURCE_DIR} ${CMAKE_SOURCE_DIR}/src/antlr)

if(PYTHON_MODULE)
	add_library(antlr SHARED ${ANTLRSOURCES})
	install(TARGETS antlr DESTINATION ${CMAKE_INSTALL_PREFIX}/lib)
else(PYTHON_MODULE)
	add_library(antlr STATIC ${ANTLRSOURCES})
endif(PYTHON_MODULE)

=== debian/changelog ===
gnudatalanguage (0.9.9-12build1) focal; urgency=medium

  * No-change rebuild to build with python3.8.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 25 Jan 2020 05:41:34 +0000

gnudatalanguage (0.9.9-12) unstable; urgency=low

  * Re-add myself to Uploaders.
  * d/control: Add support for GLPK.
  * Add fdo desktop file and icon.

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Wed, 09 Oct 2019 10:25:22 +0200

gnudatalanguage (0.9.9-11) unstable; urgency=medium

  [ Axel Beckert ]
  * Switch wxWidgets from GTK 2 to GTK 3. (Closes: #934099)

  [ Ole Streicher ]
  * Build-depend on libeccodes-dev instead of libgrib_api-dev (Closes: #939380)
  * Add gitlab-ci.yml for salsa
  * Push Standardss-Version to 4.4.0. No changes needed.
  * Push compat to 12. Remove d/compat
  * Provide CFLAGS etc. to test helper compilation
  * Fix Python 3 support
  * Add test_total to xfail tests: may require too much memory

 -- Ole Streicher <olebole@debian.org>  Sun, 15 Sep 2019 13:05:28 +0200

gnudatalanguage (0.9.9-10) unstable; urgency=medium

  * Initialize GraphicsMagick on library load (Closes: #927307)

 -- Ole Streicher <olebole@debian.org>  Tue, 23 Apr 2019 13:43:56 +0200

gnudatalanguage (0.9.9-9) unstable; urgency=medium

  * Skip TEST_L64 test (Closes: #923437)

 -- Ole Streicher <olebole@debian.org>  Thu, 28 Feb 2019 14:07:04 +0100

gnudatalanguage (0.9.9-8) unstable; urgency=medium

  * Switch to Python 3

 -- Ole Streicher <olebole@debian.org>  Thu, 10 Jan 2019 16:44:15 +0100

gnudatalanguage (0.9.9-7) unstable; urgency=medium

  * Disable more long-running tests
  * Update d/copyright for new code

 -- Ole Streicher <olebole@debian.org>  Thu, 10 Jan 2019 11:37:33 +0100

gnudatalanguage (0.9.9-6) unstable; urgency=medium

  * Remove tests that take too long on some archs

 -- Ole Streicher <olebole@debian.org>  Wed, 09 Jan 2019 09:40:36 +0100

gnudatalanguage (0.9.9-5) unstable; urgency=medium

  * Switch off altivec on more places
  * Disable tests that may take too long on arm64

 -- Ole Streicher <olebole@debian.org>  Tue, 08 Jan 2019 20:40:29 +0100

gnudatalanguage (0.9.9-4) unstable; urgency=medium

  * Fix ppc64el FTBS fix

 -- Ole Streicher <olebole@debian.org>  Tue, 08 Jan 2019 15:18:18 +0100

gnudatalanguage (0.9.9-3) unstable; urgency=medium

  * Disable specialized code that causes problems on powerpc
  * Handle python/numpy dependencies
  * Remove unused lintuian override

 -- Ole Streicher <olebole@debian.org>  Tue, 08 Jan 2019 13:39:35 +0100

gnudatalanguage (0.9.9-2) unstable; urgency=medium

  * Add some known failing tests to ignore
  * Drop unneeded using namespace std that conflicts with ALTIVEC vector
  * Temporarily disable HDF-5 support. Closes: #915207
  * Push Standards-Version to 4.3.0. No changes needed.

 -- Ole Streicher <olebole@debian.org>  Wed, 02 Jan 2019 16:02:15 +0100

gnudatalanguage (0.9.9-1) unstable; urgency=medium

  * Switch upstream repository to github
  * New upstream version 0.9.9. Rediff patches. Closes: #915207
  * Push Standards-Version to 4.2.1. No changes needed
  * Add new build dependency libgeotiff-dev

 -- Ole Streicher <olebole@debian.org>  Sat, 01 Dec 2018 20:30:14 +0100

gnudatalanguage (0.9.8-7) unstable; urgency=low

  * Disable test_matrix_multiply which takes too long on MIPS

 -- Ole Streicher <olebole@debian.org>  Wed, 30 May 2018 08:49:01 -0700

gnudatalanguage (0.9.8-6) unstable; urgency=low

  * Add numpy to Python test dependencies
  * Update failing tests

 -- Ole Streicher <olebole@debian.org>  Tue, 29 May 2018 09:56:50 -0700

=== debian/control ===
Source: gnudatalanguage
Maintainer: Debian Astronomy Team <debian-astro-maintainers@lists.alioth.debian.org>
Uploaders: Ole Streicher <olebole@debian.org>,
           Axel Beckert <abe@debian.org>,
           Gürkan Myczko <gurkan@phys.ethz.ch>
Section: interpreters
Priority: optional
Build-Depends: cmake,
               debhelper-compat (= 12),
               dh-python,
               dpkg-dev (>= 1.16.1~),
               libantlr-dev,
               libeigen3-dev (>= 3.2.4),
               libeigen3-dev (>= 3.3~alpha1-3) [arm64],
               libfftw3-dev,
               libgeotiff-dev,
               libgraphicsmagick++1-dev,
               libeccodes-dev,
               libgsl-dev,
               libhdf4-alt-dev,
               libhdf5-dev,
               libproj-dev,
               libglpk-dev,
               libncurses-dev,
               libnetcdf-dev,
               libplplot-dev (>= 5.13.0+dfsg-~),
               libqhull-dev,
               libreadline-dev,
               libudunits2-dev,
               libwxgtk3.0-gtk3-dev,
               plplot-driver-xwin,
               pslib-dev,
               python3-dev,
               python3-numpy,
               xauth,
               xvfb,
               zlib1g-dev
Standards-Version: 4.4.0
Homepage: https://github.com/gnudatalanguage/gdl
Vcs-Git: https://salsa.debian.org/debian-astro-team/gnudatalanguage.git
Vcs-Browser: https://salsa.debian.org/debian-astro-team/gnudatalanguage
Rules-Requires-Root: no

Package: libgnudatalanguage0
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Breaks: gnudatalanguage (<< 0.9.5-7~)
Replaces: gnudatalanguage (<< 0.9.5-7~)
Description: Free IDL compatible incremental compiler shared library
 GNU Data Language (GDL) is a free IDL (Interactive Data Language)
 compatible incremental compiler. It has full syntax compatibility
 with IDL 7.1. IDL is a registered trademark of ITT Visual Information
 Solutions.
 .
 This package contains the shared library which is used by the different
 frontends (gdl binary, Python package).

Package: gnudatalanguage
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Recommends: plplot-driver-xwin,
            python3-numpy
Description: Free IDL compatible incremental compiler
 GNU Data Language (GDL) is a free IDL (Interactive Data Language)
 compatible incremental compiler. It has full syntax compatibility
 with IDL 7.1. IDL is a registered trademark of ITT Visual Information
 Solutions. From IDL 8.0, the following language elements are
 supported:
 .
  * FOREACH loop
  * negative array indices
  * garbage collection pointers and objects
  * call methods on an object using "." (e. g. `object.aMemberProcedure,arg1`)
 .
 The file input output system is fully implemented. GUI support (widgets) is
 officially provided, but it's not complete yet.
 .
 This package contains the main commandline and interpreter frontend.

Package: python3-gdl
Architecture: any
Multi-Arch: same
Section: python
Depends: ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Provides: ${python3:Provides}
Recommends: plplot-driver-xwin
Description: Python interface for the GNU Data Language
 GNU Data Language (GDL) is a free IDL (Interactive Data Language)
 compatible incremental compiler. It has full syntax compatibility
 with IDL 7.1. IDL is a registered trademark of ITT Visual Information
 Solutions. From IDL 8.0, the following language elements are
 supported:
 .
  * FOREACH loop
  * negative array indices
  * garbage collection pointers and objects
  * call methods on an object using "." (e. g. `object.aMemberProcedure,arg1`)
 .
 The file input output system is fully implemented. GUI support (widgets) is
 officially provided, but it's not complete yet.
 .
 This package contains the Python library/interface.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

CXXFLAGS += -DBUILD_DATE="\"$(shell LC_ALL=C date -u --date=@"$(SOURCE_DATE_EPOCH)" +'%b %e %Y')\"" -std=gnu++11

# taken from https://bugs.debian.org/895214
# less debug info to avoid running out of address space
ifneq (,$(filter $(DEB_HOST_ARCH), mips mipsel))
  export CXXFLAGS += -g1
endif

%:
	dh $@ -Scmake --with python3

override_dh_auto_configure:
	dh_auto_configure -- \
	  -DDEB_BUILD_MULTIARCH=`dpkg-architecture -qDEB_BUILD_MULTIARCH` \
	  -DHDF5=NO \
	  -DFFTW=YES \
	  -DLIBPROJ4=YES \
	  -DGLPK=YES \
	  -DPYTHON=YES \
	  -DPYTHONVERSION=3 \
	  -DPYTHON_MODULE=YES \
	  -DWXWIDGETS=YES \
	  -DGRIB=YES \
	  -DQHULL=YES \
	  -DUDUNITS=YES \
	  -DPSLIB=YES

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	( cd obj*/testsuite \
	&& $(CXX) $(CXXFLAGS) -o libtest_ce.so ../../testsuite/libtest_ce.cpp -shared -fPIC \
	&& $(CC) $(CFLAGS) $(CPPFLAGS) $(LDFLAGS) -o launchtest ../../testsuite/launchtest.c )
	LD_LIBRARY_PATH="../src" xvfb-run dh_auto_test --no-parallel -Scmake || true
endif

override_dh_compress:
	dh_compress -X.pro

override_dh_auto_install:
	dh_auto_install
	dh_numpy3

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%gnudatalanguage-$1.tar.gz%" \
  https://github.com/gnudatalanguage/gdl/tags \
  (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate

## gnudatalanguage 1.0.0

=== CMakeLists.txt ===
#
# copyright : (c) 2010 Maxime Lenoir and Alain Coulais
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#

cmake_minimum_required(VERSION 3.2 FATAL_ERROR)

project(GDL)
set(CMAKE_CXX_STANDARD 11)

# advice by Orion, mandatory for FC 28
set(CMAKE_POSITION_INDEPENDENT_CODE ON)

# X.X.X git becomes release X.X.X+1
set(VERSION "1.0.0")
enable_testing()

# cf issue 511, managing MultiArch on Debian ...
include(GNUInstallDirs)

include(CheckIncludeFile)
include(CheckIncludeFileCXX)
include(CheckLibraryExists)
include(CheckFunctionExists)
include(CheckSymbolExists)
include(CheckCSourceRuns)
include(CheckCXXSourceCompiles)
include(FindPkgConfig)
include(FindPackageHandleStandardArgs)
include(TestBigEndian)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_SOURCE_DIR}/CMakeModules)
#### GDL is an interactive tool. Normally INTERACTIVE_GRAPHICS must be set
set(INTERACTIVE_GRAPHICS ON CACHE BOOL "GDL: Disable check of existence of a suited graphics driver in plplot.)")

#### Default cached values
set(GDLDEV OFF CACHE BOOL "GDL: Enable GDL developer mode (includes work-in-progress tests)")

set(PYTHON_MODULE OFF CACHE BOOL "GDL: Build GDL as a Python module ?")

set(X11 OFF CACHE BOOL "GDL: Enable X11 ?") 
set(X11DIR "" CACHE PATH "GDL: Specify X11 directory tree")

# Only GNU Readline since May 2020 (too complex to manage BSD Editline. See #754)
set(READLINE ON CACHE BOOL "GDL: Enable GNU Readline ?")
set(READLINEDIR "" CACHE PATH "GDL: Specify the GNU Readline directory tree")

set(PLPLOTDIR "" CACHE PATH "GDL: Specify the plplot directory tree")

set(GSLDIR "" CACHE PATH "GDL: Specify the GSL directory tree")

set(ZLIBDIR "" CACHE PATH "GDL: Specify the Zlib directory tree")

set(WXWIDGETS ON CACHE BOOL "GDL: Enable WxWidgets ?")
set(WXWIDGETSDIR "" CACHE PATH "GDL: Specify WxWidgets directory tree")

set(UDUNITS2 ON CACHE BOOL "GDL: Enable UDUNITS-2 ?")
set(UDUNITS2DIR "" CACHE PATH "GDL: Specify the UDUNITS-2 directory tree")

set(EIGEN3 ON CACHE BOOL "GDL: Enable Eigen3 ?")
set(EIGEN3DIR "" CACHE PATH "GDL: Specify the Eigen3 directory tree")

set(PNGLIB ON CACHE BOOL "GDL: Enable libpng ?")
set(PNGLIBDIR "" CACHE PATH "GDL: Specify the libpng directory tree")

set(GRIB ON CACHE BOOL "GDL: Enable GRIB ?")
set(GRIBDIR "" CACHE PATH "GDL: Specify the ECMWF ecCodes directory tree")

# set(QHULL OFF CACHE BOOL "GDL: Enable Qhull ?")
# set(QHULLDIR "" CACHE PATH "GDL: Specify the QHULL directory tree")

set(GLPK ON CACHE BOOL "GDL: Enable GLPK (for function SIMPLEX) ?")
set(GLPKDIR "" CACHE PATH "GDL: Specify the GLPK directory tree")

# GraphicsMagick is a good alternative to ImageMagick, if GM OK, we don't look for IM
set(GRAPHICSMAGICK ON CACHE BOOL "GDL: Enable GraphicsMagick ?")
set(GRAPHICSMAGICKDIR "" CACHE PATH "GDL: Specify the GraphicsMagick directory tree")

set(MAGICK ON CACHE BOOL "GDL: Enable ImageMagick ?")
set(MAGICKDIR "" CACHE PATH "GDL: Specify the ImageMagick directory tree")

set(TIFF ON CACHE BOOL "GDL: Enable libtiff ?")
set(TIFFDIR "" CACHE PATH "GDL: Specify the libtiff directory tree")

if(TIFF)
    set(GEOTIFF ON CACHE BOOL "GDL: Enable libgeotiff ?")
    set(GEOTIFFDIR "" CACHE PATH "GDL: Specify the libgeotiff directory tree")
endif(TIFF)

set(NETCDF ON CACHE BOOL "GDL: Enable NetCDF ?")
set(NETCDFDIR "" CACHE PATH "GDL: Specify the netCDF directory tree")

set(HDF ON CACHE BOOL "GDL: Enable HDF ?")
set(HDFDIR "" CACHE PATH "GDL: Specify the HDF directory tree")

set(HDF5 ON CACHE BOOL "GDL: Enable HDF5 ?")
set(HDF5DIR "" CACHE PATH "GDL: Specify the HDF5 directory tree")

set(FFTW ON CACHE BOOL "GDL: Enable FFTW ?")
set(FFTWDIR "" CACHE PATH "GDL: Specify the FFTW directory tree")

set(LIBPROJ ON CACHE BOOL "GDL: Enable PROJ ?")
set(LIBPROJDIR "" CACHE PATH "GDL: Specifiy the PROJ directory tree")

set(MPI OFF CACHE BOOL "GDL: Enable MPI ?")
set(MPIDIR "" CACHE PATH "GDL: Specify the MPI (experimental) directory tree")

set(PYTHON ON CACHE BOOL "GDL: Enable Python ?")
set(PYTHONDIR "" CACHE PATH "GDL: Specify the use Python directory tree")
set(PYTHONVERSION "" CACHE STRING "GDL: Specify the Python version to use")

set(SHAPELIB ON CACHE BOOL "GDL: Enable SHAPELIB (for IDLffShape, MAP_CONTINENTS and all geographic data?)")
set(SHAPELIBDIR "" CACHE PATH "GDL: Specify the SHAPELIB directory tree")

set(EXPAT ON CACHE BOOL "GDL: Enable EXPAT (for IDLffXMLSAX)")
set(EXPATDIR "" CACHE PATH "GDL: Specify the libEXPAT-devel directory tree")

if(NOT WIN32)
  set(NCURSESDIR "" CACHE PATH "GDL: Specify the ncurses (or curses) directory tree")
endif(NOT WIN32)

set(OPENMP ON CACHE BOOL "GDL: Enable OpenMP ?")

# Third party libraries
set(JASPERDIR "" CACHE PATH "GDL: Specify the JasPer directory tree")
set(JPEGDIR "" CACHE PATH "GDL: Specify the JPEG directory tree")
set(SZIPDIR "" CACHE PATH "GDL: Specify the SZip directory tree")

set(GDL_DATA_DIR "/share/gnudatalanguage" CACHE PATH "GDL: data directory relative to CMAKE_INSTALL_PREFIX")

# check for 64-bit OS
if(${CMAKE_SIZEOF_VOID_P} EQUAL 8)
    set(HAVE_64BIT_OS 1)
endif(${CMAKE_SIZEOF_VOID_P} EQUAL 8)

# check for endianness, and set macro in case it is big.
TEST_BIG_ENDIAN(IS_BIGENDIAN)

#### check headers and libraries

# dl
check_library_exists(dl dlopen "" HAVE_DL)
if(HAVE_DL)
    set(LIBRARIES ${LIBRARIES} dl)
endif(HAVE_DL)

# malloc stats
check_function_exists(malloc_zone_statistics HAVE_MALLOC_ZONE_STATISTICS)
check_function_exists(sbrk HAVE_SBRK)
check_function_exists(mallinfo HAVE_MALLINFO)
check_function_exists(mallinfo2 HAVE_MALLINFO2)

# mallocs
check_include_file(malloc.h HAVE_MALLOC_H)
check_include_file(malloc/malloc.h HAVE_MALLOC_MALLOC_H)

# locale
check_include_file(locale.h HAVE_LOCALE_H)

# std includes..
check_include_file(stdint.h HAVE_STDINT_H)
check_include_file(stdlib.h HAVE_STDLIB_H)
check_include_file(string.h HAVE_STRING_H)
check_include_file(strings.h HAVE_STRINGS_H)
check_include_file(sys/stat.h HAVE_SYS_STAT_H)
check_include_file(sys/types.h HAVE_SYS_TYPES_H)
check_include_file(unistd.h HAVE_UNISTD_H)
#check_include_file(ext/stdio_filebuf.h HAVE_EXT_STDIO_FILEBUF_H)
#sometimes it compiles but stdio_filebuf is only in gcc-x-y-z directory tree...
# would be silly not to use this functionality if present, so recheck:
if (HAVE_EXT_STDIO_FILEBUF_H)
else (HAVE_EXT_STDIO_FILEBUF_H)
    check_cxx_source_compiles("
#include <ext/stdio_filebuf.h>
int main(int argc, char **argv) {
    int i=0;
    i+=1;
}" REALLY_HAVE_EXT_STDIO_FILEBUF_H)
endif (HAVE_EXT_STDIO_FILEBUF_H)
if (REALLY_HAVE_EXT_STDIO_FILEBUF_H)
message(STATUS "INFO: will use GNU extensions for STDIO (useful for compressed I/O) since it seems accepted by your c++ compiler.")
set (HAVE_EXT_STDIO_FILEBUF_H 1)
endif (REALLY_HAVE_EXT_STDIO_FILEBUF_H)
# dlfcn.h
check_include_file(dlfcn.h HAVE_DLFCN_H)

# inttypes.h
check_include_file(inttypes.h HAVE_INTTYPES_H)

# nexttoward
check_library_exists(m nexttoward "" HAVE_NEXTTOWARD)

# mpi
check_include_file(mpi.h HAVE_MPI_H)

# SA: whithout it compilation of antlr fails if there's a conflicting 
#     version of antlr in system-wide directories
include_directories(src)

if (NOT WIN32)
    # Ncurses MANDATORY for readline on POSIX
    # -DNCURSESDIR=DIR
    set(CMAKE_PREFIX_PATH ${NCURSESDIR})    
    set(CURSES_NEED_NCURSES TRUE)
    find_package(Curses QUIET COMPONENTS initscr)
    mark_as_advanced(CURSES_CURSES_H_PATH CURSES_FORM_LIBRARY CURSES_HAVE_CURSES_H)
    if(CURSES_FOUND)
        set(HAVE_LIBNCURSES 1)
        set(LIBRARIES ${LIBRARIES} ${CURSES_LIBRARIES})
        include_directories(${CURSES_INCLUDE_DIR})
    else(CURSES_FOUND)
        # search for curses
        set(CURSES_NEED_NCURSES FALSE)
        find_package(Curses COMPONENTS initscr)
        set(HAVE_LIBCURSES ${CURSES_FOUND})
        if(CURSES_FOUND)
            set(LIBRARIES ${LIBRARIES} ${CURSES_LIBRARIES})
            include_directories(${CURSES_INCLUDE_DIR})
        else(CURSES_FOUND)
            message(FATAL_ERROR "(N)Curses was not found.\n"
                "Use -DNCURSESDIR=DIR to specify the curses directory tree.\n"
                "(suitable Debian/Ubuntu package: libncurses-dev)\n")
        endif(CURSES_FOUND)
    endif(CURSES_FOUND)
endif (NOT WIN32)

# -DREADLINE=ON|OFF
# -DREADLINEDIR=DIR
if(READLINE)
  set(CMAKE_PREFIX_PATH ${READLINEDIR})
  find_package(Readline QUIET)
  set(HAVE_LIBREADLINE ${READLINE_FOUND})
  if(READLINE_FOUND)
    if(NOT WIN32)
      # readline needs (n)curses (not on Windows)
      set(CMAKE_REQUIRED_LIBRARIES ${CURSES_LIBRARIES})
    endif(NOT WIN32)
    check_library_exists("${READLINE_LIBRARIES}" rl_get_screen_size "" RL_GET_SCREEN_SIZE)
    if(NOT RL_GET_SCREEN_SIZE)
      message(STATUS "WARNING: Older GNU readline without rl_get_screen_size was found.\n"
    "For resized terminals the size might not be updated correctly.\n"
    "If this is a problem please install a recent version of readline.")
    endif(NOT RL_GET_SCREEN_SIZE)
    set(LIBRARIES ${LIBRARIES} ${READLINE_LIBRARIES})
    include_directories(${READLINE_INCLUDE_DIR})
    set(CMAKE_REQUIRED_LIBRARIES)
  else(READLINE_FOUND)
    message(FATAL_ERROR "GNU readline was not found.\n"
      "Use -DREADLINE=no to explicitely disable it.\n"
      "(suitable Debian/Ubuntu package: libreadline-gplv2-dev or libreadline-dev)\n"
      "(suitable Fedora/CentOS package: readline-devel)")
  endif(READLINE_FOUND)
endif(READLINE)

# zlib MANDATORY
# -DZLIBDIR=DIR
set(CMAKE_PREFIX_PATH ${ZLIBDIR})
find_package(ZLIB QUIET)
set(HAVE_LIBZ ${ZLIB_FOUND})
if(ZLIB_FOUND)
    set(LIBRARIES ${LIBRARIES} ${ZLIB_LIBRARIES})
    include_directories(${ZLIB_INCLUDE_DIR})
else(ZLIB_FOUND)
    message(FATAL_ERROR "ZLib library is required but was not found.\n"
    "Use -DZLIBDIR=DIR to specify the zlib directory tree.\n"
        "(suitable Debian/Ubuntu package: zlib1g-dev)\n"
        "(suitable Fedora/CentOS package: zlib-devel)")
endif(ZLIB_FOUND)

# libpng
# -DPNGLIB=ON|OFF
# -DPNGLIBDIR=DIR
if(PNGLIB)
    set(CMAKE_PREFIX_PATH ${PNGLIBDIR})
    find_package(PNG QUIET)
    set(USE_PNGLIB ${PNG_FOUND})
    if(PNG_FOUND)
        set(LIBRARIES ${LIBRARIES} ${PNG_LIBRARIES})
        set(LINK_DIRECTORIES ${LINK_DIRECTORIES} ${PNG_LIBRARY_DIRS})
        include_directories(${PNG_INCLUDE_DIRS})
    else(PNG_FOUND)
        message(FATAL_ERROR "libpng is required but was not found.\n"
        "Use -DPNGLIBDIR=DIR to specify the libpng directory tree.\n"
        "Use -DPNGLIB=OFF to not use it.\n"
                "(suitable Debian/Ubuntu package: libpng-dev)\n"
                "(suitable Fedora/CentOS package: libpng-devel)")
    endif(PNG_FOUND)
endif(PNGLIB)

# openmp
# -DOPENMP=ON|OFF
if(OPENMP)
  find_package(OpenMP QUIET)
  set(USE_OPENMP ${OPENMP_FOUND})
  if(OPENMP_FOUND)
    if(MSVC)
      set(LIBRARIES ${LIBRARIES} vcomp)
    elseif(WIN32)
      set(LIBRARIES ${LIBRARIES} gomp pthread)
    else()
      set(LIBRARIES ${LIBRARIES} ${OpenMP_CXX_FLAGS})
    endif()
    if(APPLE)
      link_directories(/usr/local/lib)
    endif()
  else(OPENMP_FOUND)
    message(FATAL_ERROR "Your compiler does not support OpenMP or OpenMP was not found"
    "note that disabling OpenMP will incur significant performance penalty !\n"
    "Use -DCMAKE_CXX_COMPILER=PATH and -DCMAKE_C_COMPILER=PATH to specify the compiler path."
    "(find_package(OpenMP) will find OpenMP only if both are set !)\n"
    "Use -DOPENMP=OFF to not use it.\n"
    "(suitable Homebrew compiler package: llvm)"
    "(suitable Homebrew library package: libomp)")
  endif(OPENMP_FOUND) 
else(OPENMP)
  # we need to define those semaphore posix symbols, do it with threads libs
  find_package(Threads)
  if(THREADS_FOUND)
    set(LIBRARIES ${LIBRARIES} ${CMAKE_THREAD_LIBS_INIT})
  else(THREADS_FOUND)
    check_library_exists(rt sem_unlink "" HAVE_RT)
    if(HAVE_RT)

=== debian/changelog ===
gnudatalanguage (1.0.0-4) unstable; urgency=medium

  [ Adrian Bunk ]
  * Revert "Use -fcommon to fix ftbfs on ARM"
  * Use -Wl,--allow-multiple-definition to workaround FTBFS on armel/armhf

  [ Ole Streicher ]
  * Push Standards-Version to 4.6.0. No changes needed

 -- Ole Streicher <olebole@debian.org>  Tue, 24 Aug 2021 09:42:09 +0200

gnudatalanguage (1.0.0-3) unstable; urgency=medium

  * Use -fcommon to fix ftbfs on ARM
  * Update failing tests for arm64el

 -- Ole Streicher <olebole@debian.org>  Fri, 20 Aug 2021 14:58:16 +0200

gnudatalanguage (1.0.0-2) unstable; urgency=medium

  * No change re-upload to overcome upload glitch

 -- Ole Streicher <olebole@debian.org>  Thu, 19 Aug 2021 20:58:03 +0200

gnudatalanguage (1.0.0-1) unstable; urgency=medium

  * New upstream version 1.0.0. Closes: #983235
  * Rediff patches
  * Push Standards-Version to 4.5.1. No changes needed
  * Update required plplot driver build dependency
  * Remove unneeded antlr subdirectory
  * Adjust auto_test preparation
  * Fix double-free leading to a crash on Python-GDL shutdown
  * Switch to unstable

 -- Ole Streicher <olebole@debian.org>  Thu, 19 Aug 2021 18:10:42 +0200

gnudatalanguage (1.0.0~rc.3-1) experimental; urgency=low

  * Remove H1_OFFSET2 patch for big endian
  * Remove local PROJ4 support patch
  * Remove disabling specialized alitvec code
  * Add copyright of resource/maps/*/continents.* (LGPL)
  * Recommend wxwidgets driver
  * New upstream version 1.0.0~rc.3
  * Rediff patches
  * Update test procedure. Update local xfail/ignore lists
  * Empty xfail list to see which are working now
  * Remove unneeded dpkg-dev build dependency

 -- Ole Streicher <olebole@debian.org>  Sat, 20 Jun 2020 15:05:21 +0200

gnudatalanguage (1.0.0~rc.2-1) experimental; urgency=low

  * New upstream version 1.0.0~rc.2. Rediff patches. Closes: #961037
  * Push Standards-Version to 4.5.0. No changes needed
  * Push dh-compat to 13
  * Update and shorten d/copyright
  * Remove unneeded minversion for dpkg-dev build dep

 -- Ole Streicher <olebole@debian.org>  Thu, 21 May 2020 10:51:41 +0200

gnudatalanguage (1.0.0~rc.1+dfsg-3) experimental; urgency=low

  * Add missing H1_OFFSET2 for big endian

 -- Ole Streicher <olebole@debian.org>  Mon, 16 Dec 2019 15:58:35 +0100

gnudatalanguage (1.0.0~rc.1+dfsg-2) experimental; urgency=low

  * New upstream version 1.0.0~rc.1+dfsg. Switch to experimental.
  * Rediff patches. Remove patches that were applied upstream
  * Remove suspicious HTML files from resource/maps
  * Update d/watch to use +dfsg and catch the RC version
  * Push Standards-Version to 4.4.1. No changes needed
  * Replace $ADTTMP by $AUTOPKGTEST_TMP in test scripts
  * Update d/copyright

 -- Ole Streicher <olebole@debian.org>  Wed, 04 Dec 2019 11:17:44 +0100

gnudatalanguage (0.9.9-13) unstable; urgency=low

  * Use TI RPC instead of Sun RPC. (Closes: #968737)

 -- Ole Streicher <olebole@debian.org>  Sun, 23 Aug 2020 14:09:01 +0200

=== debian/rules ===
--- 
+++ 
@@ -11,6 +11,10 @@
 ifneq (,$(filter $(DEB_HOST_ARCH), mips mipsel))
   export CXXFLAGS += -g1
 endif
+
+# Workaround for
+# https://github.com/gnudatalanguage/gdl/issues/677
+LDFLAGS += -Wl,--allow-multiple-definition
 
 %:
 	dh $@ -Scmake --with python3
@@ -34,10 +38,10 @@
 override_dh_auto_test:
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
 	( cd obj*/testsuite \
-	&& $(CXX) $(CXXFLAGS) -o libtest_ce.so ../../testsuite/libtest_ce.cpp -shared -fPIC \
-	&& $(CC) $(CFLAGS) $(CPPFLAGS) $(LDFLAGS) -o launchtest ../../testsuite/launchtest.c )
+	&& $(CXX) $(CXXFLAGS) $(CPPFLAGS) $(LDFLAGS) -o libtest_ce.so ../../testsuite/libtest_ce.cpp -shared -fPIC )
 	LD_LIBRARY_PATH="../src" xvfb-run dh_auto_test --no-parallel -Scmake || true
 endif
+
 
 override_dh_compress:
 	dh_compress -X.pro
